/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.system.action;

import java.util.Date;

import jp.mosp.common.CommonConst;
import jp.mosp.common.MosPAction;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.common.dao.MCodeDao;
import jp.mosp.common.dto.MCodeDto;
import jp.mosp.common.utils.DateUtil;
import jp.mosp.common.utils.StringUtil;
import jp.mosp.kintai.system.vo.CodeMasterCardVo;
import jp.mosp.kintai.system.vo.HolidayMasterCardVo;

/**
 * @author yoshida
 *
 */
public class HolidayMasterCardAction extends MosPAction {
	
	// コマンド
	private static final String	CMD_HOLIDAY_MASTER_CARD_SHOW	= "S2715";	// 表示(追加)
	private static final String	CMD_HOLIDAY_MASTER_CARD_SELECT	= "S2716";	// 表示(選択)
	private static final String	CMD_HOLIDAY_MASTER_CARD_INSERT	= "S2717";	// 登録
	private static final String	CMD_HOLIDAY_MASTER_CARD_UPDATE	= "S2718";	// 更新
	private static final String	CMD_HOLIDAY_MASTER_CARD_DELETE	= "S2719";	// 削除
																			
	
	/**
	 * コンストラクタ
	 */
	public HolidayMasterCardAction() {
		super();
	}
	
	/**
	 * アクション
	 */
	public void action() throws Exception {
		// VOの取得及び設定
		prepareVo(false);
		// 初期処理
		init();
		// コマンド毎の処理
		if (cmd.equals(CMD_HOLIDAY_MASTER_CARD_SHOW)) {
			// 表示
			show();
		} else if (cmd.equals(CMD_HOLIDAY_MASTER_CARD_SELECT)) {
			// 表示(キーで情報を検索)
			select();
		} else if (cmd.equals(CMD_HOLIDAY_MASTER_CARD_INSERT)) {
			// 新規登録
			insert();
		} else if (cmd.equals(CMD_HOLIDAY_MASTER_CARD_UPDATE)) {
			// 更新
			update();
		} else if (cmd.equals(CMD_HOLIDAY_MASTER_CARD_DELETE)) {
			// 削除
			delete();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	@Override
	protected BaseVo getSpecificVo() {
		return new HolidayMasterCardVo();
	}
	
	@Override
	protected void init() throws Exception {
		// DBコネクション取得
		getConnection();
		// SYSTEM権限確認
		confirmSystemAuth();
		HolidayMasterCardVo vo = (HolidayMasterCardVo)getVo();
		// プルダウンの設定
		vo.aryPltMonth = StringUtil.getMonthArray();
		vo.aryPltDay = StringUtil.getDayArray();
	}
	
	@Override
	protected void show() {
		HolidayMasterCardVo vo = (HolidayMasterCardVo)getVo();
		Date todayDate = DateUtil.getSystemDate();
		// 初期値設定
		vo.setTxtHolidayYear(String.valueOf(MospUtility.getYear(todayDate)));
		vo.setPltHolidayMonth(String.valueOf(MospUtility.getMonth(todayDate)));
		vo.setPltHolidayDay(String.valueOf(MospUtility.getDay(todayDate)));
		vo.setTxtHolidayName("");
		// モード設定
		vo.setMode(CodeMasterCardVo.MODE_INSERT);
	}
	
	@Override
	protected void select() throws Exception {
		HolidayMasterCardVo vo = (HolidayMasterCardVo)getVo();
		// データの取得
		MCodeDto dto = part().mospcode().findForKey(CommonConst.NAM_HOLIDAY, key1);
		chkExist(dto);
		// VOに情報をセット
		vo.setFields(dto);
		// モード設定
		setMode();
		// セッションにDTOをセット
		setSessionDto(dto);
	}
	
	@Override
	protected void insert() throws Exception {
		HolidayMasterCardVo vo = (HolidayMasterCardVo)getVo();
		vo.setParams(request);
		// パラメータの妥当性確認
		vo.validate();
		// DTOの準備
		MCodeDto dto = new MCodeDto();
		vo.setDtoFields(dto);
		// DAOの準備
		MCodeDao dao = part().mospcode().getMCodeDao();
		// 存在チェック
		chkDuplicate(dao.findForKey(dto.getTId(), dto.getTCode()));
		// データの挿入
		dao.insert(dto);
		// DTOの再取得
		MCodeDto retDto = dao.findForKey(dto.getTId(), dto.getTCode());
		chkInsert(retDto);
		// コミット
		commit();
		// モード設定
		setMode();
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_INSERT, ""));
		// セッションにDTOをセット
		setSessionDto(retDto);
	}
	
	@Override
	protected void update() throws Exception {
		// DTOの取得
		MCodeDto dto = (MCodeDto)getSessionDto();
		HolidayMasterCardVo vo = (HolidayMasterCardVo)getVo();
		vo.setParams(request);
		String holiday = dto.getTCode();
		if (holiday.startsWith("0") || holiday.startsWith("1")) {
			vo.setTxtHolidayYear("");
			vo.setPltHolidayMonth(StringUtil.removeZero(holiday.split(CommonConst.SEPARATOR_DATE)[0]));
			vo.setPltHolidayDay(StringUtil.removeZero(holiday.split(CommonConst.SEPARATOR_DATE)[1]));
		} else {
			vo.setTxtHolidayYear(String.valueOf(MospUtility.getYear(DateUtil.convStringDateToDate(holiday))));
			vo.setPltHolidayMonth(String.valueOf(MospUtility.getMonth(DateUtil.convStringDateToDate(holiday))));
			vo.setPltHolidayDay(String.valueOf(MospUtility.getDay(DateUtil.convStringDateToDate(holiday))));
		}
		// パラメータの妥当性確認
		vo.validate();
		// DTOの準備
		vo.setDtoFields(dto);
		// DAOの準備
		MCodeDao dao = part().mospcode().getMCodeDao();
		// 排他確認
		chkExclusive(dto, dao.findForUpdate(dto.getTId(), dto.getTCode()));
		// データの更新
		dao.update(dto);
		// DTOの再取得
		MCodeDto retDto = dao.findForKey(dto.getTId(), dto.getTCode());
		chkUpdate(retDto);
		// コミット
		commit();
		// モード設定
		setMode();
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_UPDATE, ""));
		// セッションにDTOをセット
		setSessionDto(retDto);
	}
	
	/**
	 * データ削除
	 * @throws Exception 	例外処理が発生した場合
	 */
	private void delete() throws Exception {
		// DTOの取得
		MCodeDto dto = (MCodeDto)getSessionDto();
		HolidayMasterCardVo vo = (HolidayMasterCardVo)getVo();
		// データの削除
		part().mospcode().getMCodeDao().delete(dto);
		// コミット
		commit();
		// モード設定
		vo.setMode(CodeMasterCardVo.MODE_INSERT);
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_DELETE, ""));
	}
	
	/**
	 * モード設定
	 * @throws Exception 	例外処理が発生した場合
	 */
	private void setMode() throws Exception {
		HolidayMasterCardVo vo = (HolidayMasterCardVo)getVo();
		// モード設定
		if (hasSystemAuth()) {
			vo.setMode(HolidayMasterCardVo.MODE_SYSTEM);
		} else {
			vo.setMode(HolidayMasterCardVo.MODE_UPDATE);
		}
	}
	
}
